﻿Imports System.IO
Imports System.Data
Imports ClosedXML.Excel
Imports System.Data.SqlClient
Imports System.Configuration

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(strConnString)
            Using cmd As New SqlCommand("SELECT TOP 30 * FROM Customers")
                Using sda As New SqlDataAdapter()
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        GridView1.DataSource = dt
                        GridView1.DataBind()
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Protected Sub OnPageIndexChanging(sender As Object, e As GridViewPageEventArgs)
        GridView1.PageIndex = e.NewPageIndex
        Me.BindGrid()
    End Sub

    Protected Sub ExportExcel(sender As Object, e As EventArgs)
        Using wb As New XLWorkbook()
            'Loop through the GridView pages.
            For i As Integer = 0 To GridView1.PageCount - 1
                'Set the Current Page.
                GridView1.PageIndex = i
                Me.BindGrid()

                'Create a DataTable with schema same as GridView columns.
                Dim dt As New DataTable("Page_" & (i + 1))
                For Each cell As TableCell In GridView1.HeaderRow.Cells
                    dt.Columns.Add(cell.Text)
                Next

                'Loop and add rows from GridView to DataTable
                For Each row As GridViewRow In GridView1.Rows
                    dt.Rows.Add()
                    For j As Integer = 0 To row.Cells.Count - 1
                        dt.Rows(dt.Rows.Count - 1)(j) = row.Cells(j).Text
                    Next
                Next

                'Add DataTable as Worksheet.
                wb.Worksheets.Add(dt)
            Next

            'Export the Excel file.
            Response.Clear()
            Response.Buffer = True
            Response.Charset = ""
            Response.ContentType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
            Response.AddHeader("content-disposition", "attachment;filename=GridView.xlsx")
            Using MyMemoryStream As New MemoryStream()
                wb.SaveAs(MyMemoryStream)
                MyMemoryStream.WriteTo(Response.OutputStream)
                Response.Flush()
                Response.[End]()
            End Using
        End Using
    End Sub
End Class

